import 'package:feed_plugin/models/user_model.dart';
import 'package:flutter/cupertino.dart';

abstract class FeedState {
  const FeedState();
}

class FeedInitialState extends FeedState {
  @override
  List<Object> get props => [];
}

class FeedLoadingState extends FeedState {
  @override
  List<Object> get props => [];
}

class FeedReadyState extends FeedState {
  final String error;
  final UserModel currentPartner;
  final UserModel currentUser;

  FeedReadyState({this.error, this.currentPartner, this.currentUser});

  @override
  List<Object> get props => [error, this.currentPartner, this.currentUser];
}

class FeedErrorState extends FeedState {
  final String error;

  FeedErrorState({@required this.error});

  @override
  List<Object> get props => [error];
}
