import 'package:feed_plugin/environment_config.dart';
import 'package:feed_plugin/pages/home_page.dart';
import 'package:feed_plugin/repo/feed_repository.dart';
import 'package:feed_plugin/service/http_service.dart';
import 'package:flutter/material.dart';
import 'package:pusher_client/pusher_client.dart';
// import 'package:pusher_client/pusher_client.dart';
// import 'package:pusher_websocket_flutter/pusher.dart';
import 'models/user_model.dart';

class FeedPlugin extends StatefulWidget {
  static void registerWith(register) {}

  static PusherClient pusher = PusherClient(
    EnvironmentConfig.PUSHER_ENV,
    PusherOptions(
      cluster: "ap2",
    ),
    autoConnect: false,
  );
  static Future connect() async {
    pusher.connect();
    // try {
    //   await Pusher.init(
    //       EnvironmentConfig.PUSHER_ENV, PusherOptions(cluster: 'ap2'));
    // } catch (e) {
    //   print(e);
    //   return false;
    // }
    // Pusher.connect(
    //     onConnectionStateChange: (val) {
    //       currentPusherState = val.currentState;
    //     },
    //     onError: (err) {});
    // PusherClient pusher = PusherClient(
    //   EnvironmentConfig.PUSHER_ENV,
    //   null,
    //   autoConnect: false,
    // );
    // pusher.connect();
    // pusher.onConnectionStateChange((state) {
    //   currentPusherState = state.currentState;
    // });

    // pusher.onConnectionError((error) {
    //   print("error: ${error.message}");
    // });
    // return true;
  }

  static disconnect() {
    pusher.disconnect();
  }

  // static String currentPusherState;

  const FeedPlugin(
      {Key key,
      @required this.token,
      @required this.firstName,
      @required this.lastName,
      @required this.about,
      @required this.profileImg,
      this.partnerCompanyName,
      this.logo,
      this.media,
      this.loc})
      : super(key: key);

  final String token;
  final String firstName;
  final String lastName;
  final String about;
  final String profileImg;
  final String partnerCompanyName;
  final String logo;
  final media;
  final loc;

  @override
  _FeedPluginState createState() => _FeedPluginState();
}

class _FeedPluginState extends State<FeedPlugin> {
  HttpService httpService;
  FeedRepository feedRepository;
  UserModel currentUser;

  @override
  void initState() {
    httpService = HttpService("gogog");
    feedRepository = FeedRepository(httpService);
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return HomePage(
      token: this.widget.token,
      firstName:
          this.widget.firstName != null && this.widget.firstName != "null"
              ? this.widget.firstName
              : "",
      lastName: this.widget.lastName != null && this.widget.lastName != "null"
          ? this.widget.lastName
          : "",
      about: this.widget.about,
      profileImg: this.widget.profileImg,
      partnerMedia: this.widget.media,
      partnerName: this.widget.partnerCompanyName,
      partnerProfileImg: this.widget.logo,
      loc: this.widget.loc,
    );
  }
}
