import 'package:feed_plugin/models/post_model.dart';
import 'package:feed_plugin/models/user_model.dart';

class PostCommentModel {
  static final PostCommentModel postCommentModel = new PostCommentModel();
  int id;
  UserModel user;
  PostModel post;
  DateTime createdAt;
  String comment;

  PostCommentModel({
    this.id,
    this.user,
    this.post,
    this.createdAt,
    this.comment,
  });

  factory PostCommentModel.fromJson(Map<String, dynamic> json) {
    UserModel user = UserModel.fromJson(json["user"]);
    PostModel post = PostModel.fromJson(json["post"]);

    return new PostCommentModel(
      id: json['id'],
      user: user,
      post: post,
      createdAt: DateTime.parse(json['createdAt'] as String),
      comment: json['comment'].toString(),
    );
  }
}
