import 'package:feed_plugin/models/poll_question_model.dart';
import 'package:feed_plugin/models/user_model.dart';

import 'poll_question_model.dart';

class PostModel {
  static final PostModel postModel = new PostModel();
  int id;
  UserModel user;
  DateTime createdAt;
  String title;
  String description;
  String type;
  String attachedUrl;
  int reportsSum;
  bool isArchive;
  PollQuestionModel pollQuestion;

  PostModel({
    this.id,
    this.user,
    this.createdAt,
    this.title,
    this.description,
    this.type,
    this.attachedUrl,
    this.reportsSum,
    this.isArchive,
    this.pollQuestion,
  });

  factory PostModel.fromJson(Map<String, dynamic> json) {
    UserModel user = UserModel.fromJson(json["user"]);
    PollQuestionModel pollQuestion = json["pollQuestion"] != null
        ? PollQuestionModel.fromJson(json["pollQuestion"])
        : null;
    return new PostModel(
      id: json['id'],
      user: user,
      createdAt: DateTime.parse(json['createdAt'] as String),
      title: json['title'].toString(),
      description: json['description'].toString(),
      type: json['type'],
      attachedUrl: json['attachedUrl'].toString(),
      reportsSum: json['reportsSum'],
      isArchive: json['isArchive'],
      pollQuestion: pollQuestion,
    );
  }
}
