import 'package:feed_plugin/models/post_comment_model.dart';
import 'package:feed_plugin/models/user_model.dart';

class ReplyCommentModel {
  static final ReplyCommentModel replyCommentModel = new ReplyCommentModel();
  int id;
  UserModel user;
  PostCommentModel postComments;
  DateTime createdAt;
  String comment;

  ReplyCommentModel({
    this.id,
    this.user,
    this.postComments,
    this.createdAt,
    this.comment,
  });

  factory ReplyCommentModel.fromJson(Map<String, dynamic> json) {
    UserModel user = UserModel.fromJson(json["user"]);
    PostCommentModel postComments = PostCommentModel.fromJson(json["postComments"]);

    return new ReplyCommentModel(
      id: json['id'],
      user: user,
      postComments: postComments,
      createdAt: DateTime.parse(json['createdAt'] as String),
      comment: json['comment'].toString(),
    );
  }
}
