import 'package:feed_plugin/models/post_model.dart';
import 'package:feed_plugin/models/report_sub_type_model.dart';
import 'package:feed_plugin/models/user_model.dart';

class ReportModel {
  static final ReportModel reportModel = new ReportModel();
  int id;
  ReportSubTypeModel type;
  PostModel post;
  UserModel user;
  DateTime createdAt;

  ReportModel({this.id, this.type, this.post, this.user, this.createdAt});

  factory ReportModel.fromJson(Map<String, dynamic> json) {
    UserModel user = UserModel.fromJson(json["user"]);
    PostModel post = PostModel.fromJson(json["post"]);
    ReportSubTypeModel type =json["type"]!=null? ReportSubTypeModel.fromJson(json["type"]):null;
    return new ReportModel(
      id: json['id'],
      type: type,
      post: post,
      user: user,
      createdAt: DateTime.parse(json['createdAt'] as String),
    );
  }
}
