import 'media.dart';

class UserModel {
  static final UserModel userModel = new UserModel();
  int id;
  String userPayloadId;
  String firstName;
  String lastName;
  String profileImg;
  String about;
  Media media;
  int partnerId;

  UserModel(
      {this.id,
      this.userPayloadId,
      this.firstName,
      this.lastName,
      this.profileImg,
      this.about,
      this.media,
      this.partnerId});

  factory UserModel.fromJson(Map<String, dynamic> json) {
    Media media = json["socialMedia"] != null
        ? Media.fromJson(json["socialMedia"])
        : null;
    int partnerid = json["partnerId"].runtimeType != int && json["partnerId"] != null
        ? int.parse(json['partnerId'])
        : json['partnerId'];
    return new UserModel(
      id: json['id'],
      userPayloadId: json['userPayloadId'].toString(),
      firstName: json['firstName'].toString(),
      lastName: json['lastName'].toString(),
      profileImg: json['profileImg'].toString(),
      about: json['about'].toString(),
      media: media,
      partnerId: partnerid,
    );
  }
}
