import 'package:feed_plugin/models/user_model.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:photo_view/photo_view.dart';

class UserImagePage extends StatelessWidget {
  const UserImagePage({
    Key key,
    @required this.userData,
  }) : super(key: key);
  final UserModel userData;

  @override
  Widget build(BuildContext context) {
    
    var width = MediaQuery.of(context).size.width;
    var height = MediaQuery.of(context).size.height;
    return Directionality(
        textDirection: TextDirection.ltr,
        child: ScreenUtilInit(
          designSize: Size(width, height),
          allowFontScaling: false,
          builder: () => Scaffold(
            backgroundColor: Colors.black,
            appBar: AppBar(
              leading: Padding(
                padding: EdgeInsets.only(
                  top: ScreenUtil().setWidth(9),
                ),
                child: IconButton(
                  onPressed: () {
                    Navigator.pop(context);
                  },
                  icon: Icon(Icons.arrow_back, color: Colors.white),
                ),
              ),
              title: Padding(
                padding: EdgeInsets.only(
                  top: ScreenUtil().setWidth(9),
                ),
                child: Text(
                  this.userData.lastName != null &&
                          this.userData.lastName != "null"
                      ? this.userData.firstName + " " + this.userData.lastName
                      : this.userData.firstName,
                ),
              ),
              backgroundColor: Colors.black,
            ),
            body: PhotoView.customChild(
                child: Image(
                  image: NetworkImage(this.userData.profileImg),
                  width: double.infinity,
                  fit: BoxFit.fitWidth,
                ),
                backgroundDecoration: BoxDecoration(
                  color: Colors.transparent,
                ),
                heroAttributes: PhotoViewHeroAttributes(
                  tag: 'image${this.userData.id}',
                )
                ),
          ),
        ));
  }
}
