import 'package:flutter/material.dart';

Map<int, Color> orangeColorShades = {
  50: Color(0xFFFFAB00).withOpacity(0.05),
  100: Color(0xFFFFAB00).withOpacity(0.1),
  200: Color(0xFFFFAB00).withOpacity(0.2),
  300: Color(0xFFFFAB00).withOpacity(0.3),
  400: Color(0xFFFFAB00).withOpacity(0.4),
  500: Color(0xFFFFAB00).withOpacity(0.5),
  600: Color(0xFFFFAB00).withOpacity(0.6),
  700: Color(0xFFFFAB00).withOpacity(0.7),
  800: Color(0xFFFFAB00).withOpacity(0.8),
  900: Color(0xFFFFAB00).withOpacity(0.9),
};

final MaterialColor kOrangeMaterialColor =
    MaterialColor(0xFFFFAB00, orangeColorShades);

final MaterialColor kOrangeColorWithOpacity =
    MaterialColor(0xFFFFE4AD, orangeColorShades);

final kPurple = Color(0xFF6A1B9A);

final kAmberColor = Colors.amberAccent[700];
final kPaleOrangeColor = Color(0xFFFFE4AD);
final kOrangeColor = Color(0xFFFCA64F);
final kGey46 = Color(0xff757575);
final kGeyDimmed = Colors.grey.shade600;
final bottomMenuGreyColor = Colors.grey.shade400;
final veryDarkBlueColor = Color(0xFF344563);

final appDarkBlueColor = Color(0xFF171725);
final appGreyBackgroundColor = Color(0xFF44444F);
final appGreyTextColor = Color(0xFFB5B5BE);
final appSkyBlueColor = Color(0xFF50B5FF);
final appOrangeColor = Color(0xFFFF974A);
final appDarkGreyTextColor = Color(0xFF92929D);
final appLightGreyBg = Color(0xFFF1F1F5);
final lineturquoise = Color(0xFF3DD598);
final feedCalendarGreyColor = Color(0xFF98A9BC);
final phonedoAppsColor = Color(0xFF083356);

Color darken(Color color, [double amount = .1]) {
  assert(amount >= 0 && amount <= 1);

  final hsl = HSLColor.fromColor(color);
  final hslDark = hsl.withLightness((hsl.lightness - amount).clamp(0.0, 1.0));

  return hslDark.toColor();
}

Color lighten(Color color, [double amount = .1]) {
  assert(amount >= 0 && amount <= 1);

  final hsl = HSLColor.fromColor(color);
  final hslLight = hsl.withLightness((hsl.lightness + amount).clamp(0.0, 1.0));

  return hslLight.toColor();
}

Map<String, Color> storyColor = {
  "Yellow": Colors.yellow,
  "Green": Colors.green,
  "Pink": Colors.pink,
  "Red": Colors.red,
  "Black": Colors.black,
  "Blue": Colors.blue,
  "Grey": Colors.grey,
  "Orange": Colors.orange,
  "Purple": Colors.purple,
};
