// import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
// import 'package:jwt_decoder/jwt_decoder.dart';
// import 'package:partners_app/bloc/app_bloc/app_bloc.dart';
// import 'package:partners_app/bloc/hotline_bloc/hotline_cubit.dart';
// import 'package:partners_app/models/hotline.dart';
// import 'package:partners_app/models/purchased_telephone.dart';
// import 'package:partners_app/repo/user_repository.dart';
// import 'package:http/http.dart' as http;
// import 'package:partners_app/services/localization/localizations.dart';
// import 'package:partners_app/services/localization/localizations.dart';
import 'package:feed_plugin/utilities/colors.dart';
// import 'package:flutter_bloc/flutter_bloc.dart';
// import 'package:partners_app/widgets/checkbox_tile.dart';
// import 'package:partners_app/widgets/grey_input_container.dart';
// import 'package:partners_app/widgets/orange_button.dart';
// import 'package:partners_app/widgets/white_input_container.dart';
import 'package:feed_plugin/widgets/date_picker/datepicker.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';

class Calendar extends StatefulWidget {
  const Calendar({
    Key key,
    @required this.loc,
  }) : super(key: key);

  final loc;

  @override
  _CalendarState createState() => _CalendarState();
}

class _CalendarState extends State<Calendar> {
  String thisButton;

  @override
  void initState() {
    thisButton = null;
    super.initState();
  }

  range(type) {
    setState(() {
      thisButton = type;
    });
  }

  @override
  Widget build(BuildContext context) {
    // final loc = PhonedoLocalizations.of(context);

    return AlertDialog(
        insetPadding: EdgeInsets.only(
            top: ScreenUtil().setHeight(30),
            left: ScreenUtil().setWidth(20),
            right: ScreenUtil().setWidth(20)),
        contentPadding: const EdgeInsets.fromLTRB(25.0, 2.0, 25.0, 15.0),
        // backgroundColor: Colors.red,
        title: Container(
            height: ScreenUtil().setHeight(30),
            alignment: Alignment.topRight,
            child: IconButton(
              onPressed: () => Navigator.of(context).pop(),
              icon: Icon(Icons.close),
            )),
        shape: RoundedRectangleBorder(
            borderRadius: BorderRadius.all(Radius.circular(20.0))),
        content: Container(
            // color: Colors.blue,
            child: SingleChildScrollView(
          child: Container(
            // color: Colors.orange,
            width: ScreenUtil().setWidth(500),
            margin: EdgeInsets.only(bottom: ScreenUtil().setHeight(10)),
            child: Column(
              children: [
                Container(
                  height: ScreenUtil().setHeight(300),
                  // padding: const EdgeInsets.only(bottom: 30),
                  // color: Colors.brown,
                  child: SfDateRangePicker(
                    backgroundColor: Colors.white,
                    todayHighlightColor: lineturquoise,
                    selectionMode: DateRangePickerSelectionMode.range,
                    selectionShape: DateRangePickerSelectionShape.rectangle,
                    selectionColor: lineturquoise,
                    headerStyle: DateRangePickerHeaderStyle(
                      // backgroundColor: lineturquoise,
                      textAlign: TextAlign.left,
                      textStyle: TextStyle(
                          color: Colors.black,
                          fontSize: ScreenUtil().setSp(17),
                          fontWeight: FontWeight.w400),
                    ),
                    headerHeight: ScreenUtil().setHeight(50),
                    selectionTextStyle: TextStyle(
                      fontStyle: FontStyle.normal,
                      fontWeight: FontWeight.w400,
                      fontSize: ScreenUtil().setSp(15),
                      color: Colors.white,
                    ),
                    startRangeSelectionColor: lineturquoise,
                    endRangeSelectionColor: lineturquoise,
                    rangeSelectionColor: lineturquoise,
                    rangeTextStyle: TextStyle(
                      fontStyle: FontStyle.normal,
                      fontWeight: FontWeight.w400,
                      fontSize: ScreenUtil().setSp(15),
                      color: Colors.white,
                    ),
                    yearCellStyle: DateRangePickerYearCellStyle(
                      textStyle: TextStyle(
                          fontWeight: FontWeight.w400,
                          fontSize: 15,
                          color: Colors.black),
                      todayTextStyle: TextStyle(
                          fontStyle: FontStyle.normal,
                          fontSize: 15,
                          fontWeight: FontWeight.w400,
                          color: Colors.black),
                    ),
                    monthCellStyle: DateRangePickerMonthCellStyle(
                      textStyle: TextStyle(
                          fontStyle: FontStyle.normal,
                          fontWeight: FontWeight.w400,
                          fontSize: ScreenUtil().setSp(15),
                          color: Colors.black),
                      todayTextStyle: TextStyle(
                        fontStyle: FontStyle.normal,
                        fontSize: ScreenUtil().setSp(15),
                        fontWeight: FontWeight.w400,
                        color: phonedoAppsColor,
                      ),
                      leadingDatesTextStyle: TextStyle(
                          fontStyle: FontStyle.normal,
                          fontWeight: FontWeight.w300,
                          fontSize: ScreenUtil().setSp(15),
                          color: Colors.grey),
                      trailingDatesTextStyle: TextStyle(
                          fontStyle: FontStyle.normal,
                          fontWeight: FontWeight.w300,
                          fontSize: ScreenUtil().setSp(15),
                          color: Colors.grey),
                      cellDecoration: BoxDecoration(
                          border:
                              Border.all(color: Colors.grey[300], width: 0.5),
                          shape: BoxShape.rectangle),
                      todayCellDecoration: BoxDecoration(
                          border:
                              Border.all(color: phonedoAppsColor, width: 0.5),
                          shape: BoxShape.rectangle),
                      trailingDatesDecoration: BoxDecoration(
                          border:
                              Border.all(color: Colors.grey[300], width: 0.5),
                          shape: BoxShape.rectangle),
                      leadingDatesDecoration: BoxDecoration(
                          border:
                              Border.all(color: Colors.grey[300], width: 0.5),
                          shape: BoxShape.rectangle),
                    ),
                    monthViewSettings: DateRangePickerMonthViewSettings(
                      firstDayOfWeek: 1,
                      dayFormat: 'EEE',
                      showTrailingAndLeadingDates: true,
                      viewHeaderHeight: ScreenUtil().setHeight(30),
                      enableSwipeSelection: false,
                      viewHeaderStyle: DateRangePickerViewHeaderStyle(
                        textStyle: TextStyle(
                          fontWeight: FontWeight.w500,
                          fontStyle: FontStyle.normal,
                          fontSize: ScreenUtil().setSp(13),
                          color: phonedoAppsColor,
                        ),
                      ),
                    ),
                    monthFormat: 'MMMM',
                  ),
                ),
                Container(
                  margin: EdgeInsets.only(top: ScreenUtil().setHeight(20)),
                  // padding: const EdgeInsets.only(left: 8.0, top: 25.0),
                  child: Container(
                    alignment: Alignment.centerLeft,
                    child: Text(
                      widget.loc.translate('Choose the time period'),
                      style: TextStyle(
                        color: feedCalendarGreyColor,
                        fontFamily: 'Rubik',
                        fontSize: ScreenUtil().setSp(15),
                      ),
                    ),
                  ),
                ),
                Container(
                    margin: EdgeInsets.only(top: ScreenUtil().setHeight(16)),
                    child: Column(
                      children: [
                        Row(children: [
                          Expanded(
                              child: Container(
                            margin: EdgeInsets.only(right: 3),
                            width: ScreenUtil().setWidth(100),
                            child: TextButton(
                              onPressed: () => range('From day 1'),
                              style: ButtonStyle(
                                  backgroundColor: thisButton == "From day 1"
                                      ? MaterialStateProperty.all(
                                          phonedoAppsColor)
                                      : MaterialStateProperty.all(Colors.white),
                                  shape: MaterialStateProperty.all(
                                    RoundedRectangleBorder(
                                        side: BorderSide(
                                            color: phonedoAppsColor,
                                            width: 1,
                                            style: BorderStyle.solid),
                                        borderRadius: BorderRadius.circular(6)),
                                  )),
                              child: Text(
                                widget.loc.translate("From day 1"),
                                style: TextStyle(
                                    color: thisButton == "From day 1"
                                        ? Colors.white
                                        : phonedoAppsColor,
                                    fontSize: ScreenUtil().setSp(13)),
                              ),
                            ),
                          )),
                          Expanded(
                              child: Container(
                                  margin: EdgeInsets.only(right: 3, left: 3),
                                  width: ScreenUtil().setWidth(100),
                                  child: TextButton(
                                    onPressed: () => range('Day'),
                                    style: ButtonStyle(
                                        backgroundColor: thisButton == "Day"
                                            ? MaterialStateProperty.all(
                                                phonedoAppsColor)
                                            : MaterialStateProperty.all(
                                                Colors.white),
                                        shape: MaterialStateProperty.all(
                                          RoundedRectangleBorder(
                                              side: BorderSide(
                                                  color: phonedoAppsColor,
                                                  width: 1,
                                                  style: BorderStyle.solid),
                                              borderRadius:
                                                  BorderRadius.circular(6)),
                                        )),
                                    child: Text(
                                      widget.loc.translate("Day"),
                                      style: TextStyle(
                                          color: thisButton == "Day"
                                              ? Colors.white
                                              : phonedoAppsColor),
                                    ),
                                  ))),
                          Expanded(
                              child: Container(
                                  margin: EdgeInsets.only(left: 3),
                                  width: ScreenUtil().setWidth(100),
                                  child: TextButton(
                                    onPressed: () => range('Week'),
                                    style: ButtonStyle(
                                        backgroundColor: thisButton == 'Week'
                                            ? MaterialStateProperty.all(
                                                phonedoAppsColor)
                                            : MaterialStateProperty.all(
                                                Colors.white),
                                        shape: MaterialStateProperty.all(
                                          RoundedRectangleBorder(
                                              side: BorderSide(
                                                  color: phonedoAppsColor,
                                                  width: 1,
                                                  style: BorderStyle.solid),
                                              borderRadius:
                                                  BorderRadius.circular(6)),
                                        )),
                                    child: Text(
                                      widget.loc.translate("Week"),
                                      style: TextStyle(
                                          color: thisButton == 'Week'
                                              ? Colors.white
                                              : phonedoAppsColor),
                                    ),
                                  ))),
                        ]),
                        Row(children: [
                          Expanded(
                              child: Container(
                                  margin: EdgeInsets.only(right: 3),
                                  width: ScreenUtil().setWidth(100),
                                  child: TextButton(
                                    onPressed: () => range('Month'),
                                    style: ButtonStyle(
                                        backgroundColor: thisButton == "Month"
                                            ? MaterialStateProperty.all(
                                                phonedoAppsColor)
                                            : MaterialStateProperty.all(
                                                Colors.white),
                                        shape: MaterialStateProperty.all(
                                          RoundedRectangleBorder(
                                              side: BorderSide(
                                                  color: phonedoAppsColor,
                                                  width: 1,
                                                  style: BorderStyle.solid),
                                              borderRadius:
                                                  BorderRadius.circular(6)),
                                        )),
                                    child: Text(
                                      widget.loc.translate("Month"),
                                      style: TextStyle(
                                          color: thisButton == "Month"
                                              ? Colors.white
                                              : phonedoAppsColor),
                                    ),
                                  ))),
                          Expanded(
                              child: Container(
                                  margin: EdgeInsets.only(left: 3, right: 3),
                                  width: ScreenUtil().setWidth(100),
                                  child: TextButton(
                                    onPressed: () => range('Year'),
                                    style: ButtonStyle(
                                        backgroundColor: thisButton == "Year"
                                            ? MaterialStateProperty.all(
                                                phonedoAppsColor)
                                            : MaterialStateProperty.all(
                                                Colors.white),
                                        shape: MaterialStateProperty.all(
                                          RoundedRectangleBorder(
                                              side: BorderSide(
                                                  color: phonedoAppsColor,
                                                  width: 1,
                                                  style: BorderStyle.solid),
                                              borderRadius:
                                                  BorderRadius.circular(6)),
                                        )),
                                    child: Text(
                                      widget.loc.translate("Year"),
                                      style: TextStyle(
                                          color: thisButton == 'Year'
                                              ? Colors.white
                                              : phonedoAppsColor),
                                    ),
                                  ))),
                          Expanded(
                            child: Text(""),
                          )
                        ]),
                      ],
                    )),
              ],
            ),
          ),
        )));
    // },
    // ),
    // );
  }
}
